# This file is generated by SciPy's build process
# It contains system_info results at the time of building this package.
from enum import Enum

__all__ = ["show"]
_built_with_meson = True


class DisplayModes(Enum):
    stdout = "stdout"
    dicts = "dicts"


def _cleanup(d):
    """
    Removes empty values in a `dict` recursively
    This ensures we remove values that Meson could not provide to CONFIG
    """
    if isinstance(d, dict):
        return { k: _cleanup(v) for k, v in d.items() if v != '' and _cleanup(v) != '' }
    else:
        return d


CONFIG = _cleanup(
    {
        "Compilers": {
            "c": {
                "name": "clang-cl",
                "linker": "lld-link",
                "version": "14.0.6",
                "commands": "clang-cl.exe",
                "args": "",
                "linker args": "",
            },
            "cython": {
                "name": "cython",
                "linker": "cython",
                "version": "3.0.8",
                "commands": "cython",
                "args": "",
                "linker args": "",
            },
            "c++": {
                "name": "clang-cl",
                "linker": "lld-link",
                "version": "14.0.6",
                "commands": "clang-cl.exe",
                "args": "",
                "linker args": "",
            },
            "fortran": {
                "name": "intel-cl",
                "linker": "xilink",
                "version": "2021.6.0",
                "commands": "ifort",
                "args": "",
                "linker args": "",
            },
            "pythran": {
                "version": "0.15.0",
                "include directory": r"..\..\_h_env\lib\site-packages\pythran"
            },
        },
        "Machine Information": {
            "host": {
                "cpu": "x86_64",
                "family": "x86_64",
                "endian": "little",
                "system": "windows",
            },
            "build": {
                "cpu": "x86_64",
                "family": "x86_64",
                "endian": "little",
                "system": "windows",
            },
            "cross-compiled": bool("False".lower().replace('false', '')),
        },
        "Build Dependencies": {
            "blas": {
                "name": "mkl-sdl",
                "found": bool("True".lower().replace('false', '')),
                "version": "2023.1",
                "detection method": "pkgconfig",
                "include directory": r"C:/b/abs_86x0wu5rr1/croot/scipy_1710947370784/_h_env/Library/include",
                "lib directory": r"C:/b/abs_86x0wu5rr1/croot/scipy_1710947370784/_h_env/Library/lib",
                "openblas configuration": "unknown",
                "pc file directory": r"C:\b\abs_86x0wu5rr1\croot\scipy_1710947370784\_h_env\Library\lib\pkgconfig",
            },
            "lapack": {
                "name": "mkl-sdl",
                "found": bool("True".lower().replace('false', '')),
                "version": "2023.1",
                "detection method": "pkgconfig",
                "include directory": r"C:/b/abs_86x0wu5rr1/croot/scipy_1710947370784/_h_env/Library/include",
                "lib directory": r"C:/b/abs_86x0wu5rr1/croot/scipy_1710947370784/_h_env/Library/lib",
                "openblas configuration": "unknown",
                "pc file directory": r"C:\b\abs_86x0wu5rr1\croot\scipy_1710947370784\_h_env\Library\lib\pkgconfig",
            },
            "pybind11": {
                "name": "pybind11",
                "version": "2.10.4",
                "detection method": "pkgconfig",
                "include directory": r"C:/b/abs_86x0wu5rr1/croot/scipy_1710947370784/_h_env/Library/include",
            },
        },
        "Python Information": {
            "path": r"C:\b\abs_86x0wu5rr1\croot\scipy_1710947370784\_h_env\python.exe",
            "version": "3.10",
        },
    }
)


def _check_pyyaml():
    import yaml

    return yaml


def show(mode=DisplayModes.stdout.value):
    """
    Show libraries and system information on which SciPy was built
    and is being used

    Parameters
    ----------
    mode : {`'stdout'`, `'dicts'`}, optional.
        Indicates how to display the config information.
        `'stdout'` prints to console, `'dicts'` returns a dictionary
        of the configuration.

    Returns
    -------
    out : {`dict`, `None`}
        If mode is `'dicts'`, a dict is returned, else None

    Notes
    -----
    1. The `'stdout'` mode will give more readable
       output if ``pyyaml`` is installed

    """
    if mode == DisplayModes.stdout.value:
        try:  # Non-standard library, check import
            yaml = _check_pyyaml()

            print(yaml.dump(CONFIG))
        except ModuleNotFoundError:
            import warnings
            import json

            warnings.warn("Install `pyyaml` for better output", stacklevel=1)
            print(json.dumps(CONFIG, indent=2))
    elif mode == DisplayModes.dicts.value:
        return CONFIG
    else:
        raise AttributeError(
            f"Invalid `mode`, use one of: {', '.join([e.value for e in DisplayModes])}"
        )
